<?php

use humhub\widgets\Button;
use yii\helpers\Html;
use yii\helpers\Url;
use humhub\compat\CActiveForm;
use humhub\compat\CHtml;
?>

<?php $this->beginContent('@admin/views/setting/_advancedLayout.php') ?>

<div class="clearfix">
    <?= Button::back(Url::to(['setting/oembed']),  Yii::t('AdminModule.settings', 'Back to overview')) ?>
    <h4 class="pull-left">
        <?php
        if ($prefix == "") {
            echo Yii::t('AdminModule.settings', 'Add OEmbed provider');
        } else {
            echo Yii::t('AdminModule.settings', 'Edit OEmbed provider');
        }
        ?>
    </h4>
</div>

<br>

<?php $form = CActiveForm::begin(['id' => 'authentication-settings-form']); ?>


<?= $form->errorSummary($model); ?>

<div class="form-group">
    <?= $form->labelEx($model, 'prefix'); ?>
    <?= $form->textField($model, 'prefix', ['class' => 'form-control']); ?>
    <p class="help-block"><?= Yii::t('AdminModule.settings', 'Url Prefix without http:// or https:// (e.g. youtube.com)'); ?></p>
</div>

<div class="form-group">
    <?= $form->labelEx($model, 'endpoint'); ?>
    <?= $form->textField($model, 'endpoint', ['class' => 'form-control']); ?>
    <p class="help-block"><?= Yii::t('AdminModule.settings', 'Use %url% as placeholder for URL. Format needs to be JSON. (e.g. http://www.youtube.com/oembed?url=%url%&format=json)'); ?></p>
</div>


<?= CHtml::submitButton(Yii::t('AdminModule.settings', 'Save'), ['class' => 'btn btn-primary', 'data-ui-loader' => ""]); ?>
<?php CActiveForm::end(); ?>

<?php if ($prefix != ""): ?>
    <?= Html::a(Yii::t('AdminModule.settings', 'Delete'), Url::to(['oembed-delete', 'prefix' => $prefix]), ['class' => 'btn btn-danger pull-right', 'data-method' => 'POST']); ?>
<?php endif; ?>

<?php $this->endContent(); ?>
